﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using GestionDeCommerceInfoClasseBDDNCouches;
using GestionDeCommerceInfoClasseBDDNCouches.DataLayer;

namespace Gestion_de_commerce_Informatique
{
    public partial class ConfigurationUtilisateur : Form
    {
        public Utilisateur user;
        BDDAccesUtilisateur bddUser;
        bool Modif;
        public ConfigurationUtilisateur(BDDAccesUtilisateur bddUser)
        {
            InitializeComponent();
            this.bddUser = bddUser;
            Modif = false;
        }
        public ConfigurationUtilisateur(Utilisateur user, BDDAccesUtilisateur bddUser)
        {
            InitializeComponent();
            this.bddUser = bddUser;
            this.user = user;
            vtbAdresse.Text = this.user.Adresse;
            vtbEmail.Text = this.user.Email;
            vtbNCompte.Text = this.user.NCompte;
            vtbNom.Text = this.user.Nom;
            vtbPrenom.Text = this.user.Prenom;
            datepickAnnif.Value = (this.user.DateDeNaisance == null)?DateTime.Now:user.DateDeNaisance.Value;
            cbType.SelectedIndex = (int)this.user.TypeUtilisateur;
            btnConfirm.Text = "Editer l'utilisateur";
            this.Text = $"Editer l'utilisateur : {user.Nom} {user.Prenom}";
            Modif = true;
        }

        private void bunifuFlatButton1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnConfirm_Click(object sender, EventArgs e)
        {
            if (Modif)
            {
                this.user.Adresse = vtbAdresse.Text;
                this.user.Email = vtbEmail.Text;
                this.user.NCompte = vtbNCompte.Text;
                this.user.Nom = vtbNom.Text;
                this.user.Prenom = vtbPrenom.Text;
                this.user.DateDeNaisance = datepickAnnif.Value;
                this.user.TypeUtilisateur = (Utilisateur.Type_E)cbType.SelectedIndex;

                bddUser.ModifUtilisateur(this.user);
                
            }
            else
            {
                user = new Utilisateur(vtbNom.Text, vtbPrenom.Text, vtbAdresse.Text, vtbNCompte.Text, vtbEmail.Text, (Utilisateur.Type_E)cbType.SelectedIndex);
                this.user.DateDeNaisance = datepickAnnif.Value;
                bddUser.AjouterUtilisateur(user);
            }
            this.Close();
        }
    }
}
